<?php

namespace Ghasedak;


use Exception;

class SmsRest extends BaseSms
{

    const PATH = "http://api.smsapp.ir/v2/sms/%s";

    protected $api;


    public function __construct($api)
    {

        parent::__construct($api);

    }

    public function send($to, $from, $text, $isFlash = false)
    {

        $textarray = explode("##", $text);
        $key = array_pop($textarray);

        $url = $this->getPath(self::PATH, 'send/simple');
        $data = [
            "receptor" => $to,
            "sender" => $from,
            "message" => $text,
            "output" => "Json"
        ];

        return $this->execute($url, $data);

    }

    protected function execute($url, $data = null)
    {

        $fields_string = "";

        if (!is_null($data)) {

            $fields_string = http_build_query($data);

        }

        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $fields_string,
            CURLOPT_HTTPHEADER => array(
                "apikey: " . $this->api,
                "Content-Type: application/x-www-form-urlencoded"
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);

        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        $curl_errno = curl_errno($curl);

        $curl_error = curl_error($curl);

        if ($curl_errno) {

            throw new Exception($curl_error);

        }

        return $response;


    }


}
